/*!
* @file GameInstance.h
* @brief GameInstanceクラスと付随要素のプロトタイプ
* @date 2014/06/02
* @author Deskull
* 2013-2014 Sikabane Works.
*/

#pragma once

#include "Deeangband.h"

namespace Deeangband
{
	/*! 
	* @class GameInstance
	* @brief ゲームの諸要素の管理を行うスーパークラス
	*/
	class GameInstance
	{
	private:


		/*!
		* @brief クラスのシリアライズを設定する
		* @param archive アーカイブ化するクラスのアドレス
		* @param version ファイルバージョン
		* @return XMLSerializeテンプレート
		*/
		template<class Archive> void serialize(Archive &archive, const unsigned int version) 
		{
		}

	protected:

		NAME name; //!< 名前
		DESCRIPTION description; //!< 解説
		bool validGenerated; //!< 正しく生成されたかの判定フラグ

	public:

		/*! 
		* @brief GameInstanceクラスコンストラクタ
		*/
		GameInstance::GameInstance(void); 

		/*! 
		* @brief GameInstanceクラスデストラクタ
		*/
		virtual GameInstance::~GameInstance(void); 

		/*! 
		* @brief ダミーデータによる初期化
		* @return なし
		*/
		virtual void GameInstance::WipeData(void) {}

		/*!
		* @brief 名前を取得する
		* @return 名前
		*/
		NAME GameInstance::GetName(void);

		/*!
		* @brief 解説を取得する
		* @return 解説
		*/
		DESCRIPTION GameInstance::GetDescription(void);

		/*!
		* @brief 所属元のGameWorldインスタンスを返す
		* @return GameWorldインスタンスの参照ポインタ
		*/
		GameWorld *GameInstance::GetGameWorld(void);

		/*!
		* @brief 所属元のGameWorldインスタンスを返す
		* @return GameWorldインスタンスの参照ポインタ
		*/
		bool GameInstance::IsValidGenerated(void);

	};

}

